package api

import (
	"encoding/json"
	"errors"
	"fmt"

	openapi "github.com/alibabacloud-go/darabonba-openapi/client"
	dysmsapi20170525 "github.com/alibabacloud-go/dysmsapi-20170525/v2/client"
	"github.com/alibabacloud-go/tea/tea"
)

func createSmsClient() (_result *dysmsapi20170525.Client, _err error) {
	accessKeyId := tea.String("LTAI4FmvA9HNunGVq6biNASf")
	accessKeySecret := tea.String("QNHsxlW0iESK15TpouJwoLQzRMSxgu")

	config := &openapi.Config{
		AccessKeyId:     accessKeyId,
		AccessKeySecret: accessKeySecret,
	}
	config.Endpoint = tea.String("dysmsapi.aliyuncs.com")
	_result, _err = dysmsapi20170525.NewClient(config)
	return _result, _err
}

type SupplierSmsReq struct {
	Porduct      string
	SerialNumber string
}

func SendSmsNotify(phone string, info *SupplierSmsReq) error {
	// TODO dev
	return errors.New("待配置短信模板")
	client, _err := createSmsClient()
	if _err != nil {
		return _err
	}

	infobytes, _ := json.Marshal(info)

	sendSmsRequest := &dysmsapi20170525.SendSmsRequest{
		PhoneNumbers:  tea.String(phone),
		SignName:      tea.String("中鱼互动"),
		TemplateCode:  tea.String("SMS_460545008"),
		TemplateParam: tea.String(string(infobytes)),
	}

	resp, err := client.SendSms(sendSmsRequest)
	if err != nil {
		return err
	}
	if *resp.Body.Code == "OK" {
		return nil
	}
	return fmt.Errorf("code err %s", *resp.Body.Code)
}
